Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/AstBuilder.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/AstBuilder.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/AstBuilder.java	(revision 9)
@@ -66,7 +66,7 @@
 import org.momut.ooas.ast.types.ListType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserError;
 import org.momut.ooas.parser.ParserState;
 
@@ -110,7 +110,7 @@
 
 
 	public static AttributeIdentifier createObjectAttribute(String varName, Identifier aClass, boolean doInstantiate, Identifier root){
-		final UlyssesType aType = aClass.type();
+		final Type aType = aClass.type();
 		aType.SetupAnonymousName(); //not sure if necessary
 		Expression anExpr;
 		if (doInstantiate){
@@ -130,7 +130,7 @@
 		return new ValueExpression<Boolean>(b, 0, 0, Boolean.class);
 	}
 
-	public static ListType createListType(UlyssesType elemType, int max, TypeIdentifier anIdentifier){
+	public static ListType createListType(Type elemType, int max, TypeIdentifier anIdentifier){
 		final ListType result = new ListType(elemType, max, null);
 		result.SetupAnonymousName();
 		result.SetTypeIdentifier(anIdentifier);
@@ -155,7 +155,7 @@
 	}
 
 
-	public static UlyssesType createIntType(int low, int high){
+	public static Type createIntType(int low, int high){
 		return new IntType(low, high, null);
 	}
 
@@ -179,7 +179,7 @@
 
 	public static AttributeIdentifier createBoolAttribute(String varname, boolean isStatic, boolean init, Identifier root){
 		final Expression anExpr = new ValueExpression<Boolean>(init, 0, 0, Boolean.class);
-		final UlyssesType aType = new BoolType(null);
+		final Type aType = new BoolType(null);
 		aType.SetupAnonymousName();
 		final AttributeIdentifier attributeIdentifier = new AttributeIdentifier(varname, aType, ((IScope)(root).type()), anExpr, isStatic, false, false );
 		((IScope)(root).type()).AddIdentifier(attributeIdentifier, null);
@@ -187,7 +187,7 @@
 		return attributeIdentifier;
 	}
 
-	public static AttributeIdentifier createAttribute(String varname, boolean isStatic, UlyssesType aType, Expression anExpr, IScope scope){
+	public static AttributeIdentifier createAttribute(String varname, boolean isStatic, Type aType, Expression anExpr, IScope scope){
 		final AttributeIdentifier attributeIdentifier = new AttributeIdentifier(varname, aType, scope, anExpr, isStatic, false, false );
 		scope.AddIdentifier(attributeIdentifier, null);
 
@@ -197,11 +197,11 @@
 	public static MethodIdentifier createMethod(
 			String name,
 			LinkedList<ParameterIdentifier> params,
-			UlyssesType returnType,
+			Type returnType,
 			Identifier as,
 			Statement body
 			) {
-		final LinkedList<UlyssesType> parameterTypes = new LinkedList<UlyssesType>();
+		final LinkedList<Type> parameterTypes = new LinkedList<Type>();
 		for (final ParameterIdentifier param : params) {
 			parameterTypes.add(param.type());
 		}
@@ -224,7 +224,7 @@
 	public static NamedActionIdentifier createActionWithoutBody(
 			FunctionType.FunctionTypeEnum functionType,
 			String name,
-			LinkedList<UlyssesType> parameters,
+			LinkedList<Type> parameters,
 			Identifier as)
 	{
 		final FunctionType actionType = new FunctionType(functionType, parameters, null);
@@ -237,7 +237,7 @@
 	public static Identifier createAction(
 			FunctionType.FunctionTypeEnum functionType,
 			String name,
-			LinkedList<UlyssesType> parameters,
+			LinkedList<Type> parameters,
 			Identifier as,
 			Statement body)
 	{
@@ -297,7 +297,7 @@
 		// -- define the (implicitly declared type of the action) --lBlock
 		final FunctionType helloWorldActionType = new FunctionType(  // this type is anonymous and doesn't have a name!
 				FunctionTypeEnum.Observable,   // This is observable, hence an action
-				new LinkedList<UlyssesType>(), // no parameters
+				new LinkedList<Type>(), // no parameters
 				null                           // void return
 		);
 		helloWorldActionType.SetupAnonymousName(); // need to be called before setting the type identifier
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/TupleType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/TupleType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/TupleType.java	(revision 9)
@@ -37,19 +37,19 @@
 ///////////////////////////////////////////////
 ///  Complex Type: TupleType
 ///
-public final class TupleType extends UlyssesType
+public final class TupleType extends Type
 {
-	private final LinkedList<UlyssesType> m_innerTypes;
+	private final LinkedList<Type> m_innerTypes;
 
-	public LinkedList<UlyssesType> innerTypes() { return m_innerTypes; }
+	public LinkedList<Type> innerTypes() { return m_innerTypes; }
 
 	public TupleType(TypeIdentifier anIdentifier)
 	{
 		super(TypeKind.TupleType, anIdentifier);
-		m_innerTypes = new LinkedList<UlyssesType>();
+		m_innerTypes = new LinkedList<Type>();
 	}
 
-	public void AddType(UlyssesType aType)
+	public void AddType(Type aType)
 	{
 		m_innerTypes.addLast(aType);
 	}
@@ -65,7 +65,7 @@
 	{
 		StringBuilder result = new StringBuilder();
 		result.append("tuple_");
-		for (UlyssesType inner: m_innerTypes)
+		for (Type inner: m_innerTypes)
 		{
 			result.append(inner.toString());
 			result.append("_");
@@ -76,7 +76,7 @@
 	@Override
 	public int valueCount() {
 		int result = 1;
-		for (final UlyssesType inner: m_innerTypes)
+		for (final Type inner: m_innerTypes)
 			result *= inner.valueCount();
 		return result;
 	}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/EnumType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/EnumType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/EnumType.java	(revision 9)
@@ -40,7 +40,7 @@
 ///////////////////////////////////////////////
 ///  Simple Type: Enumeration
 ///
-public class EnumType extends UlyssesType
+public class EnumType extends Type
 {
 	protected SymbolTable m_enumSymbols;
 	protected ArrayList<EnumIdentifier> m_listOfEnumSymbols;
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/IAstVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/IAstVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/IAstVisitor.java	(revision 9)
@@ -36,7 +36,6 @@
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
 import org.momut.ooas.ast.expressions.ObjectConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
 import org.momut.ooas.ast.expressions.TupleConstructor;
@@ -49,7 +48,6 @@
 import org.momut.ooas.ast.identifiers.ConstantIdentifier;
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.ExpressionVariableIdentifier;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.identifiers.LocalVariableIdentifier;
 import org.momut.ooas.ast.identifiers.MainModule;
 import org.momut.ooas.ast.identifiers.MethodIdentifier;
@@ -70,7 +68,6 @@
 import org.momut.ooas.ast.statements.KillStatement;
 import org.momut.ooas.ast.statements.NondetBlock;
 import org.momut.ooas.ast.statements.PrioBlock;
-import org.momut.ooas.ast.statements.QualitativeConstraintStatement;
 import org.momut.ooas.ast.statements.SeqBlock;
 import org.momut.ooas.ast.statements.SkipStatement;
 import org.momut.ooas.ast.types.AnyType;
@@ -85,7 +82,6 @@
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 
 /*Notice: The visitor must implement the traversal!*/
@@ -96,7 +92,6 @@
 
 	/*Identifiers*/
 	void visit(EnumIdentifier enumIdentifier);
-	void visit(LandmarkIdentifier landmarkIdentifier);
 	void visit(AttributeIdentifier attributeIdentifier);
 	void visit(ExpressionVariableIdentifier expressionVariableIdentifier);
 	void visit(ParameterIdentifier parameterIdentifier);
@@ -124,7 +119,6 @@
 	void visit(SkipStatement skipStatement);
 	void visit(AbortStatement abortStatement);
 	void visit(KillStatement killStatement);
-	void visit(QualitativeConstraintStatement qalitativeConstraintStatement);
 
 
 	/*Expressions*/
@@ -136,7 +130,6 @@
 	void visit(MapConstructor mapConstructor);
 	void visit(TupleConstructor tupleConstructor);
 	void visit(ObjectConstructor objectConstructor);
-	void visit(QValConstructor qValConstructor);
 	void visit(AccessExpression accessExpression);
 	void visit(BinaryOperator binaryOperator);
 	void visit(TernaryOperator ternaryOperator);
@@ -155,7 +148,6 @@
 	void visit(EnumType enumType);
 	void visit(ListType listType);
 	void visit(MapType mapType);
-	void visit(QrType qrType);
 	void visit(TupleType tupleType);
 	void visit(FunctionType functionType);
 	void visit(OoActionSystemType ooActionSystemType);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/FunctionType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/FunctionType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/FunctionType.java	(revision 9)
@@ -34,7 +34,7 @@
 ///////////////////////////////////////////////
 ///  Complex Type: Function
 ///
-public final class FunctionType extends UlyssesType
+public final class FunctionType extends Type
 {
 	public enum FunctionTypeEnum {
 		Observable (0),
@@ -52,23 +52,23 @@
 
 	private Boolean m_miracleSafe = null;
 	private boolean m_pure;
-	private LinkedList<UlyssesType> m_parameter;
-	private UlyssesType m_returnType;
+	private LinkedList<Type> m_parameter;
+	private Type m_returnType;
 	private final FunctionTypeEnum m_functionType;
 
 	public Boolean isMiracleSafe() { return m_miracleSafe; }
 	public boolean isPureFunction() { return m_pure; }
-	public LinkedList<UlyssesType> parameter() { return m_parameter; }
-	public UlyssesType returnType() { return m_returnType; }
+	public LinkedList<Type> parameter() { return m_parameter; }
+	public Type returnType() { return m_returnType; }
 	public FunctionTypeEnum functionType() { return m_functionType; }
 
-	public FunctionType(FunctionTypeEnum functionType, LinkedList<UlyssesType> parameter, UlyssesType returnType)
+	public FunctionType(FunctionTypeEnum functionType, LinkedList<Type> parameter, Type returnType)
 	{
 		super (TypeKind.FunctionType, null);
 		if (parameter != null)
 			m_parameter = parameter;
 		else
-			m_parameter = new LinkedList<UlyssesType>();
+			m_parameter = new LinkedList<Type>();
 		m_returnType = returnType;
 		m_functionType = functionType;
 		m_miracleSafe = null;
@@ -76,12 +76,12 @@
 	}
 
 
-	public void AddParameterType(UlyssesType aType)
+	public void AddParameterType(Type aType)
 	{
 		m_parameter.addLast(aType);
 	}
 
-	public void SetReturnType(UlyssesType aType)
+	public void SetReturnType(Type aType)
 	{
 		m_returnType = aType;
 	}
@@ -109,7 +109,7 @@
 		result.append("fun_");
 		result.append(m_functionType.toString());
 		result.append("_");
-		for (final UlyssesType sym: m_parameter)
+		for (final Type sym: m_parameter)
 		{
 			result.append(sym.toString());
 			result.append("_");
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpExpression.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpExpression.java	(revision 9)
@@ -61,10 +61,9 @@
 import org.momut.ooas.ast.types.MapType;
 import org.momut.ooas.ast.types.OoActionSystemInstance;
 import org.momut.ooas.ast.types.OoActionSystemType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.parser.SymbolTable;
 import org.momut.ooas.visitors.OoaExpressionVisitor;
@@ -486,7 +485,7 @@
 		m_emitter = tmp;
 
 		// treat cases of MyTuple(a,b..) = <expr>
-		final Iterator<UlyssesType> elem = ((TupleType)tupleConstructor.type()).innerTypes().iterator();
+		final Iterator<Type> elem = ((TupleType)tupleConstructor.type()).innerTypes().iterator();
 		int i = 0;
 		m_emitter.Append("(");
 		while (elem.hasNext())
@@ -594,7 +593,7 @@
 
 		CadpType.EmitType(binaryOperator.type());
 		final ListType alist = (ListType)binaryOperator.type();
-		final UlyssesType innerType = alist.innerType();
+		final Type innerType = alist.innerType();
 		final String resultTypeName = CadpIdentifier.GetIdentifierString(binaryOperator.type().identifier());
 
 		m_helperCode.AppendLine(String.format("%4$s %3$s(%1$s listA, %2$s listB){", childATypeName, childBTypeName, result, resultTypeName));
@@ -695,7 +694,7 @@
 
 		CadpType.EmitType(binaryOperator.type());
 		final ListType alist = (ListType)binaryOperator.type();
-		final UlyssesType innerType = alist.innerType();
+		final Type innerType = alist.innerType();
 		final String resultTypeName = CadpIdentifier.GetIdentifierString(binaryOperator.type().identifier());
 
 		m_helperCode.AppendLine(String.format("%4$s %3$s(%1$s listA, %2$s listB){", childATypeName, childBTypeName, result, resultTypeName));
@@ -755,10 +754,10 @@
 
 			final FunctionType fun = (FunctionType)leftcall.child().type();
 			final FunctionIdentifier funid = (FunctionIdentifier) fun.identifier();
-			final Iterator<UlyssesType> node = fun.parameter().iterator();
+			final Iterator<Type> node = fun.parameter().iterator();
 			for (int i = 0; i < fun.parameter().size() - 2; i++)
 			{
-				final UlyssesType nodeValue = node.next();
+				final Type nodeValue = node.next();
 				paramtypes.add(CadpType.DumpType(nodeValue));
 				final CadpIdentifier paramid = new CadpIdentifier(m_procInfo.stateVariableString);
 				funid.parameter().get(i).Accept(paramid);
@@ -1107,7 +1106,7 @@
 	/* The cast support in this target instanceof limited: We can not cast differently sized types!
 	 * Hence list and map lengths must be equal.
 	 * */
-	private boolean CADPCastEquivalent(UlyssesType type1, UlyssesType type2)
+	private boolean CADPCastEquivalent(Type type1, Type type2)
 	{
 		if ((type1 == null) || (type2 == null))
 			return false;
@@ -1141,21 +1140,17 @@
 			return CADPCastEquivalent(mapt1.fromType(), mapt2.fromType()) &&
 					CADPCastEquivalent(mapt1.toType(), mapt2.toType()) &&
 					mapt1.maxNumberOfElements() == mapt2.maxNumberOfElements();
-		case QrType:
-			final QrType qr1 = (QrType)type1;
-			final QrType qr2 = (QrType)type2;
-			return qr1 == qr2; // ref eq.
 		case TupleType:
 			final TupleType tuplet1 = (TupleType)type1;
 			final TupleType tuplet2 = (TupleType)type2;
 			if (tuplet1.innerTypes().size() != tuplet2.innerTypes().size())
 				return false;
-			final Iterator<UlyssesType> innert1 = tuplet1.innerTypes().iterator();
-			final Iterator<UlyssesType> innert2 = tuplet2.innerTypes().iterator();
+			final Iterator<Type> innert1 = tuplet1.innerTypes().iterator();
+			final Iterator<Type> innert2 = tuplet2.innerTypes().iterator();
 			while (innert1.hasNext())
 			{
-				final UlyssesType innert1Value = innert1.next();
-				final UlyssesType innert2Value = innert2.next();
+				final Type innert1Value = innert1.next();
+				final Type innert2Value = innert2.next();
 
 				if (!CADPCastEquivalent(innert1Value, innert2Value))
 					return false;
@@ -1163,7 +1158,7 @@
 			return true;
 		case OoActionSystemType:
 			return type1 == type2 /*ref. eq.*/ ||
-					UlyssesType.Covariance((OoActionSystemType)type2, (OoActionSystemType)type1);
+					Type.Covariance((OoActionSystemType)type2, (OoActionSystemType)type1);
 		case OpaqueType:
 			throw new IllegalArgumentException();
 		case Null:
@@ -1291,7 +1286,7 @@
 					unaryOperator.type().Accept(targetType);
 					final CadpType sourceType = new CadpType();
 					unaryOperator.child().type().Accept(sourceType);
-					if (!(UlyssesType.Covariance((OoActionSystemType)unaryOperator.child().type(), (OoActionSystemType)unaryOperator.type())))
+					if (!(Type.Covariance((OoActionSystemType)unaryOperator.child().type(), (OoActionSystemType)unaryOperator.type())))
 					{
 						// cast result type (unaryOperator.type) not a sub-type of unaryOperator.child.type
 						return String.format("/* up-cast: %1$s as %2$s */ *(%2$s*)&", sourceType.ToString(), targetType.ToString());
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpType.java	(revision 9)
@@ -51,10 +51,9 @@
 import org.momut.ooas.ast.types.OoActionSystemInstance;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.ValuedEnumType;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.parser.SymbolTable;
@@ -154,11 +153,6 @@
 	{
 		throw new UnsupportedOperationException();
 	}
-	@Override
-	public  void visit(QrType qrType)
-	{
-		throw new UnsupportedOperationException();
-	}
 
 	@Override
 	public  void visit(FunctionType functionType)
@@ -189,7 +183,7 @@
 		super(null);
 	}
 
-	public static String DumpType(UlyssesType atype)
+	public static String DumpType(Type atype)
 	{
 		final CadpType newtype = new CadpType();
 		atype.Accept(newtype);
@@ -199,7 +193,7 @@
 
 	private static HashSet<String> emittedTypes = new HashSet<String>();
 
-	private static void EmitType(UlyssesType aType, OoasCodeEmitter emitter)
+	private static void EmitType(Type aType, OoasCodeEmitter emitter)
 	{
 		final String typename = CadpIdentifier.GetIdentifierString(aType.identifier());
 		if (!emittedTypes.contains(typename))
@@ -559,7 +553,7 @@
 		emitter.AppendLine("#endif");
 		emitter.AppendLineIncIndent(String.format("struct struct_%1$s {", typeName));
 		int i = 0;
-		for (final UlyssesType it: atupleType.innerTypes())
+		for (final Type it: atupleType.innerTypes())
 		{
 			EmitType(it);
 			emitter.AppendLine(String.format("%1$s elem_%2$s;", DumpType(it), i));
@@ -575,7 +569,7 @@
 		emitter.AppendLine(String.format("/*%1$s%2$s*/", constructorString, typeName));
 		emitter.Append(String.format("%1$s %2$s%1$s (", typeName, constructorString));
 		i = 0;
-		for (final UlyssesType it: atupleType.innerTypes())
+		for (final Type it: atupleType.innerTypes())
 		{
 			if (!emittedTypes.contains(CadpIdentifier.GetIdentifierString(it.identifier())))
 				EmitType(it, result);
@@ -587,7 +581,7 @@
 		emitter.AppendLineIncIndent(") {");
 		emitter.AppendLine(String.format("%1$s result;", typeName));
 		i = 0;
-		for (final UlyssesType it:  atupleType.innerTypes())
+		for (final Type it:  atupleType.innerTypes())
 		{
 			emitter.AppendLine(String.format("result.elem_%1$s = arg_%1$s;", i));
 			/*do range checking on ints and floats*/
@@ -623,7 +617,7 @@
 		emitter.AppendLine(String.format("/*%1$s%2$s*/", highString, typeName));
 		emitter.Append(String.format("long long int %2$s%1$s (void) { return ", typeName, highString));
 		i = 0;
-		for (final UlyssesType x : atupleType.innerTypes())
+		for (final Type x : atupleType.innerTypes())
 		{
 			if (i != 0)
 				emitter.Append(" * ");
@@ -640,7 +634,7 @@
 		emitter.Append(String.format("return %2$s%1$s (", typeName, constructorString));
 		i = 0;
 		final StringBuilder divisor = new StringBuilder("value");
-		for (final UlyssesType it: atupleType.innerTypes())
+		for (final Type it: atupleType.innerTypes())
 		{
 			if (i != 0)
 				emitter.Append(",");
@@ -656,7 +650,7 @@
 		emitter.AppendLine(String.format("void %1$s%2$s (CAESAR_TYPE_FILE CAESAR_FILE, %2$s A_VALUE)", printString, typeName));
 		emitter.AppendLine("{");
 		emitter.AppendLine(String.format("  fprintf(CAESAR_FILE,\" (\");"));
-		final Iterator<UlyssesType> iter = atupleType.innerTypes().iterator();
+		final Iterator<Type> iter = atupleType.innerTypes().iterator();
 		for (i = 0; i < atupleType.innerTypes().size(); i++)
 		{
 			if (i != 0)
@@ -831,21 +825,21 @@
 
 
 
-	public static String GetMaxVal(UlyssesType atype)
+	public static String GetMaxVal(Type atype)
 	{
 		return String.format(" (%2$s%1$s() - 1) ", GetIdentifierString(atype.identifier()), highString);
 	}
 
-	public static String GetMinVal(UlyssesType atype)
+	public static String GetMinVal(Type atype)
 	{
 		return String.format(" %2$s%1$s() ", GetIdentifierString(atype.identifier()), lowString);
 	}
 
-	public static String GetEnumVal(UlyssesType atype, String indexvar)
+	public static String GetEnumVal(Type atype, String indexvar)
 	{
 		return String.format(" %2$s%1$s(%3$s)", GetIdentifierString(atype.identifier()), enumString, indexvar);
 	}
-	public static String GetEnumVal(UlyssesType atype)
+	public static String GetEnumVal(Type atype)
 	{
 		return String.format(" %2$s%1$s", GetIdentifierString(atype.identifier()), enumString);
 	}
@@ -856,7 +850,7 @@
 	private static OoasCodeEmitter m_classTypeDefinitions = new OoasCodeEmitter();
 	private static OoasCodeEmitter m_typeDefinitions = new OoasCodeEmitter();
 
-	public static void EmitType(UlyssesType aType)
+	public static void EmitType(Type aType)
 	{
 		EmitType(aType, m_typeDefinitions);
 	}
@@ -875,7 +869,7 @@
 		return result.toString();
 	}
 
-	public static boolean IsNumeric(UlyssesType ulyssesType)
+	public static boolean IsNumeric(Type ulyssesType)
 	{
 		switch (ulyssesType.kind())
 		{
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaInitVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaInitVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaInitVisitor.java	(revision 9)
@@ -43,7 +43,7 @@
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.parser.ParserError;
 import org.momut.ooas.parser.ParserMessage;
@@ -54,7 +54,7 @@
 {
 	private final String SimulationNameSpace = "org.momut.ooas.codegen.java.simulation";
 	private final OoasCodeEmitter emitter;
-	private final ArrayList<UlyssesType> hiddenTypesStillToEmit = new ArrayList<UlyssesType>();
+	private final ArrayList<Type> hiddenTypesStillToEmit = new ArrayList<Type>();
 	private final Scratchbook scratchbook = new Scratchbook();
 	private StringBuilder helpers = new StringBuilder();
 
@@ -115,7 +115,7 @@
 			? actionSystemClass.parent.objectInstance
 			: null;
 
-		final HashSet<UlyssesType> seenTypes = new HashSet<UlyssesType>();
+		final HashSet<Type> seenTypes = new HashSet<Type>();
 		final StringBuilder instantiationPath = new StringBuilder();
 		if (aParentInstance != null)
 		{
@@ -128,7 +128,7 @@
 			}
 		}
 
-		UlyssesType tmpType = atype;
+		Type tmpType = atype;
 		while (tmpType != null)
 		{
 			if (seenTypes.contains(tmpType))
@@ -169,7 +169,7 @@
 		if (ConstrNum >= 0)
 			scratchbook.constructors().get(ConstrNum).AddInstance(actionSystemClass.objectInstance);
 	}
-	private String GetCSharpType(UlyssesType aType)
+	private String GetCSharpType(Type aType)
 	{
 		if (aType.isAnonymousType())
 			hiddenTypesStillToEmit.add(aType);
@@ -266,7 +266,7 @@
 	{
 		emitter.AppendLineIncIndent(String.format("public static class %s {", GetIdentifierString(atupleType.identifier().tokenText())));
 		int i = 0;
-		for (final UlyssesType it: atupleType.innerTypes())
+		for (final Type it: atupleType.innerTypes())
 		{
 			emitter.AppendLine(String.format("public %s elem_%s;", GetCSharpType(it), Integer.toString(i)));
 			i++;
@@ -275,7 +275,7 @@
 		emitter.AppendLine(" /*constr*/ ");
 		emitter.Append(String.format("public %s (", GetIdentifierString(atupleType.identifier().tokenText())));
 		i = 0;
-		for (final UlyssesType it: atupleType.innerTypes())
+		for (final Type it: atupleType.innerTypes())
 		{
 			if (i != 0)
 				emitter.Append(",");
@@ -313,7 +313,7 @@
 	protected void VisitAstElement(IAst element, IAst parent)
 	{
 		if (element.nodeType() == AstNodeTypeEnum.type &&
-				((UlyssesType)element).kind() == TypeKind.OoActionSystemType)
+				((Type)element).kind() == TypeKind.OoActionSystemType)
 		{
 			/*OoActionSystemType asystem = (OoActionSystemType)element;
 			if (asystem.autoConstruction)
@@ -321,12 +321,12 @@
 			Emit((OoActionSystemType)element);
 		}
 		else if (element.nodeType() == AstNodeTypeEnum.type &&
-				((UlyssesType)element).kind() == TypeKind.TupleType)
+				((Type)element).kind() == TypeKind.TupleType)
 		{
 			Emit((TupleType)element);
 		}
 		else if (element.nodeType() == AstNodeTypeEnum.type &&
-				((UlyssesType)element).kind() == TypeKind.EnumeratedType)
+				((Type)element).kind() == TypeKind.EnumeratedType)
 		{
 			Emit((EnumType)element);
 		}
@@ -348,7 +348,7 @@
 		super.visit(mainModule);
 
 		emitter.AppendLine(" /* == anonymous types == */ ");
-		for (final UlyssesType x: hiddenTypesStillToEmit)
+		for (final Type x: hiddenTypesStillToEmit)
 		{
 			// we only need to define tuples and enums..
 			if (x.kind() == TypeKind.TupleType)
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/ListType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/ListType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/ListType.java	(revision 9)
@@ -34,15 +34,15 @@
 ///////////////////////////////////////////////
 ///  Complex Type: List
 ///
-public final class ListType extends UlyssesType
+public final class ListType extends Type
 {
-	private UlyssesType m_innerType;
+	private Type m_innerType;
 	private final int m_maxNumberOfElements;
 
-	public UlyssesType innerType() { return m_innerType; }
+	public Type innerType() { return m_innerType; }
 	public int maxNumberOfElements() { return m_maxNumberOfElements; }
 
-	public ListType(UlyssesType elemType, int max, TypeIdentifier anIdentifier)
+	public ListType(Type elemType, int max, TypeIdentifier anIdentifier)
 	{
 		super(TypeKind.ListType, anIdentifier);
 		m_innerType = elemType;
@@ -55,7 +55,7 @@
 		visitor.visit(this);
 	}
 
-	public void SetInnerType(UlyssesType newType)
+	public void SetInnerType(Type newType)
 	{
 		if (newType == null)
 			throw new ArgumentException();
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/NullType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/NullType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/NullType.java	(revision 9)
@@ -32,7 +32,7 @@
 ///////////////////////////////////////////////
 ///  Special type: null
 ///
-public final class NullType extends UlyssesType
+public final class NullType extends Type
 {
 	public NullType()
 	{
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/OpaqueType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/OpaqueType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/OpaqueType.java	(revision 9)
@@ -33,11 +33,11 @@
 ///////////////////////////////////////////////
 ///  Opaque Type..
 ///
-public class OpaqueType extends UlyssesType
+public class OpaqueType extends Type
 {
-	private UlyssesType m_resolvedType;
+	private Type m_resolvedType;
 
-	public UlyssesType resolvedType() { return m_resolvedType; }
+	public Type resolvedType() { return m_resolvedType; }
 
 	public OpaqueType(TypeIdentifier reference)
 	{
@@ -44,7 +44,7 @@
 		super(TypeKind.OpaqueType, reference);
 	}
 
-	public void SetResolvedType(UlyssesType aType)
+	public void SetResolvedType(Type aType)
 	{
 		m_resolvedType = aType;
 	}
